# SPDX-License-Identifier: CC0-1.0


def encrypt_spi(pixels, key1, key2, key3, tn=0):
    # to mame style (Big Endian)
    mame = ((pixels & 0x00_00FF) << 16
            | (pixels & 0x00_FF00)
            | (pixels & 0xFF_0000) >> 16)

    xor = mame ^ key3

    suma = tn + key1

    # no carry last
    assert not (key2 & 0x80_0000)
    e = 0
    carry = 0
    for i in range(24):
        bit = ((xor >> i) & 1) ^ ((suma >> i) & 1) ^ carry
        bitsum = bit + ((suma >> i) & 1) + carry
        carry = (bitsum >> 1) if ((key2 >> i) & 1) else 0
        e |= ((bit & 1) << i)

    # Reorder bits
    reordered = ((e & 0x80_0000) >> 5
                 | (e & 0x40_0000) >> 3
                 | (e & 0x20_0000) >> 12
                 | (e & 0x10_0020) >> 15

                 | (e & 0x08_0000) >> 9
                 | (e & 0x04_0000) >> 1
                 | (e & 0x02_0000) >> 1
                 | (e & 0x01_0000) << 4


                 | (e & 0x00_8000) << 6
                 | (e & 0x00_4000) << 8
                 | (e & 0x00_2000) >> 7
                 | (e & 0x00_1000) >> 1

                 | (e & 0x00_0800) << 4
                 | (e & 0x00_0400) << 4
                 | (e & 0x00_0200) >> 5
                 | (e & 0x00_0100) << 15

                 | (e & 0x00_0080) >> 7
                 | (e & 0x00_0040) >> 5
                 | (e & 0x00_0020) << 2
                 | (e & 0x00_0010) << 4

                 | (e & 0x00_0008) << 10
                 | (e & 0x00_0004) << 10
                 | (e & 0x00_0002) << 2
                 | (e & 0x00_0001) << 2)

    return struct.pack('>I', reordered)[1:]
